//+------------------------------------------------------------------+
//|                                          profitunity_signals.mq4 |
//|                                          Necron,2010             |
//+------------------------------------------------------------------+
//      Oasis`a   KimIV
//FindNearFractal(); 
//     Profitunity     
// true/false; 
/*
#import "profitunity_signals.ex4"
  double AO(int Shift);//    AO   shift 
  bool bull_dish();// 
  bool bear_dish();// 
  bool bull_cross();//   
  bool bear_cross();//   
 // bool two_high_peaks();//    
 // bool two_low_peaks();//    
  double AC(int Shift);//    AC   shift
  bool bull_double_bar_above();//2    
  bool bull_triple_bar_below();//    
  bool bull_cross_and_double_bar();//      
  bool bear_double_bar_below();//    
  bool bear_triple_bar_above();//    
  bool bear_cross_and_double_bar();//      
  bool green_zone();// 
  bool red_zone();// 
  double FindNearFractal(string sy="0", int tf=0, int mode=MODE_LOWER); 
  double teeth(int shift);
#import
// :
if(bull_dish()) {}
*/

#property library   

//+------------------------------------------------------------------+
//|  AO                                             |
//+------------------------------------------------------------------+
  double AO(int Shift)//    AO   shift 
   {
     return(NormalizeDouble(iAO(NULL, 0, Shift), Digits + 2));
   }
  bool bull_dish()// 
   {
     if(AO(1)>AO(2) && AO(3)>AO(2) && AO(1)>0 && AO(2)>0 && AO(3)>0)
     return(true);else return(false); 
     
   } 
  bool bear_dish()// 
   {
     if(AO(1)<AO(2) && AO(3)<AO(2) && AO(1)<0 && AO(2)<0 && AO(3)<0)
     return(true);else return (false);
   }
  bool bull_cross()//   
   {
     if(AO(2)<0 && AO(1)>0)
     return(true);else return(false);
   }
  bool bear_cross()//   
   {
     if(AO(2)>0 && AO(1)<0)
     return(true);else return(false);
   }
 /*      
 int get_high_peak(int start)// Luptator`a -        
   {
     double ao0=0,ao1=0,ao2=0;
     int retn_shift=0;
    for(int i=start;i<Bars;i++)
      {
         ao0=iAO(NULL,0,i);
         ao1=iAO(NULL,0,i+1);
         ao2=iAO(NULL,0,i+2);
         if(ao0>0 && ao2>0 && ao0<ao1 && ao1>ao2)
            {
              retn_shift=0;
              break;
            }
      }
      return(retn_shift);
   }
 bool two_high_peaks()//    
   {
    int high_peak1=get_high_peak(1);
    int high_peak2=get_high_peak(high_peak1);
    if(iAO(NULL,0,high_peak1)<iAO(NULL,0,high_peak2))
    return(true);else return(false);
   } 
   
 int get_low_peak(int start)// Luptator`a -         
   {
     double ao0=0,ao1=0,ao2=0;
     int retn_shift=0;
    for(int i=start;i<Bars;i++)
      {
         ao0=iAO(NULL,0,i);
         ao1=iAO(NULL,0,i+1);
         ao2=iAO(NULL,0,i+2);
         if(ao0<0 && ao2<0 && ao0>ao1 && ao1<ao2)
            {
              retn_shift=0;
              break;
            }
      }
      return(retn_shift);
   }
   
 bool two_low_peaks()//    
   {
    int high_peak1=get_high_peak(0);
    int high_peak2=get_high_peak(high_peak1);
    if(iAO(NULL,0,high_peak1)>iAO(NULL,0,high_peak2))
    return(true);else return(false);
   }  
*/
//+------------------------------------------------------------------+
//|  AC                                             |
//+------------------------------------------------------------------+
   double AC(int Shift)//    AC   shift
     {
       return(NormalizeDouble(iAO(NULL, 0, Shift), Digits + 2));
     }
   bool bull_double_bar_above()//2    
     {
      if(AC(1)>AC(2) && AC(2)>AC(3) && AC(3) < AC(4) && AC(3) > 0)
      return(true);else return(false);
     }
   bool bull_triple_bar_below()//    
     {
      if(AC(1) > AC(2) && AC(2)>AC(3) && AC(3)>AC(4) && AC(4)<AC(5) && ((AC(1) < 0) ||(AC(1) > 0 && AC(2) < 0)))
      return(true); else return(false);
     }
   bool bull_cross_and_double_bar()//      
     {
      if(AC(1)>AC(2) && AC(2)>AC(3) && AC(3)<AC(4) && AC(1)>0 && AC(2)<0)
      return(true); else return(false);
     }
   bool bear_double_bar_below()//    
     { 
      if(AC(1)<AC(2) && AC(2)<AC(3) && AC(3)>AC(4) && AC(3)<0)
      return(true); else return(false);
     }
   bool bear_triple_bar_above()//    
     {
      if(AC(1)<AC(2) && AC(2)<AC(3) && AC(3)<AC(4)&& AC(4)>AC(5) && ((AC(1)>0) || (AC(1)<0 && AC(2)>0)))
      return(true); else return(false);
     }
   bool bear_cross_and_double_bar()//      
     {
      if(AC(1)<AC(2) && AC(2)<AC(3) && AC(3)>AC(4) && AC(1)<0 && AC(2)>0)
      return(true); else return(false);
     }
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
   bool green_zone()// 
    {
     if(AO(1)>AO(2) && AC(1)>AC(2))
     return(true);else return(false);
    }
   bool red_zone()// 
    { 
     if(AO(1)<AO(2) && AC(1)<AC(2))
     return(true);else return(false);
    }
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
//      fr_up=(FindNearFractal(NULL,0,MODE_UPPER));
//      fr_dn=(FindNearFractal(NULL,0,MODE_LOWER));
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//  ,   KimIV                            |
//+----------------------------------------------------------------------------+
//|     :   . aka KimIV,  http://www.kimiv.ru                    |
//+----------------------------------------------------------------------------+
//|    : 07.10.2006                                                      |
//|  :   .                                      |
//+----------------------------------------------------------------------------+
//| :                                                                 |
//|   sy -       (NULL -  )                |
//|   tf -                     (  0  -  )                    |
//|   mode -                 (MODE_LOWER|MODE_UPPER)                |
//+----------------------------------------------------------------------------+
double FindNearFractal(string sy="0", int tf=0, int mode=MODE_LOWER) {
  if (sy=="" || sy=="0") sy=Symbol();
  double f=0;
  int d=MarketInfo(sy, MODE_DIGITS), s;
  if (d==0) if (StringFind(sy, "JPY")<0) d=4; else d=2;

  for (s=3; s<100; s++) {
    f=iFractals(sy, tf, mode, s);
    if (f!=0) return(NormalizeDouble(f, d));
  }
  Print("FindNearFractal():   ");
  return(0);
 }
//+------------------------------------------------------------------+
//|                     |
//+------------------------------------------------------------------+
 double teeth(int shift)
   {
    double teeth;
    teeth=iAlligator(NULL, 0, 13, 8, 8, 5, 5, 3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORTEETH,shift);
    return(NormalizeDouble(teeth,Digits));
   }
       
   